]> git.pld-linux.org Git - packages/rpm-build-tools.git/blame - builder.sh
- dummy %patchset_source
[packages/rpm-build-tools.git] / builder.sh
CommitLineData
1d7abbe3 1#!/bin/ksh
cd445739
AM
2# -----------
3# $Id$
4# Exit codes:
2a5f078d 5# 0 - succesful
6# 1 - help displayed
7# 2 - no spec file name in cmdl parameters
8# 3 - spec file not stored in repo
9# 4 - some source, patch or icon files not stored in repo
10# 5 - package build failed
11# 6 - spec file with errors
12# 7 - wrong source in /etc/poldek.conf
13# 8 - Failed installing buildrequirements and subrequirements
14# 9 - Requested tag already exist
15# 10 - Refused to build fractional release
16# 100 - Unknown error (should not happen)
cd445739
AM
17
18# Notes (todo):
f7b91886 19# - builder -u fetches current version first (well that's okay, how you compare versions if you have no old spec?)
cd445739 20# - when Icon: field is present, -5 and -a5 doesn't work
f3ada241 21# - builder -R skips installing BR if spec is not present before builder invocation (need to run builder twice)
931a4acf 22
4003ad8c 23VERSION="\
c9acaed9 24Build package utility from PLD Linux CVS repository
ac1516e0 25v0.17 (C) 1999-2006 Free Penguins".
d6a77ddb 26PATH="/bin:/usr/bin:/usr/sbin:/sbin:/usr/X11R6/bin"
b03f053b 27
cd445739 28COMMAND="build"
64ea5308 29TARGET=""
cd445739 30
bde1c404 31SPECFILE=""
d287305c 32BE_VERBOSE=""
4003ad8c 33QUIET=""
cd445739
AM
34CLEAN=""
35DEBUG=""
36NOURLS=""
37NOCVS=""
38NOCVSSPEC=""
39NODIST=""
47761337 40NOINIT=""
cd445739 41UPDATE=""
cd445739
AM
42ADD5=""
43NO5=""
44ALWAYS_CVSUP=${ALWAYS_CVSUP:-"yes"}
c8f50498 45CVSROOT=""
cd445739
AM
46
47# It can be used i.e. in log file naming.
48# See LOGFILE example.
49DATE=`date +%Y-%m-%d_%H-%M-%S`
50
51# Example: LOGFILE='../log.$PACKAGE_NAME'
52# Example: LOGFILE='../LOGS/log.$PACKAGE_NAME.$DATE'
53# Yes, you can use variable name! Note _single_ quotes!
54LOGFILE=''
55
56LOGDIR=""
57LOGDIROK=""
58LOGDIRFAIL=""
59LASTLOG_FILE=""
60
61CHMOD="no"
62CHMOD_MODE="0444"
63RPMOPTS=""
d1c5a9a7 64RPMBUILDOPTS=""
cd445739
AM
65BCOND=""
66GROUP_BCONDS="no"
947025e5 67CVSIGNORE_DF="no"
d287305c 68
69PATCHES=""
70SOURCES=""
cd445739 71ICONS=""
d287305c 72PACKAGE_RELEASE=""
73PACKAGE_VERSION=""
74PACKAGE_NAME=""
cd445739
AM
75PROTOCOL="ftp"
76WGET_RETRIES=${MAX_WGET_RETRIES:-0}
77CVS_RETRIES=${MAX_CVS_RETRIES:-1000}
78
79CVSTAG=""
80RES_FILE=""
39dcc7de 81CVS_FORCE=""
cd445739
AM
82
83CVS_SERVER="cvs.pld-linux.org"
84DISTFILES_SERVER="://distfiles.pld-linux.org"
d4730dae 85ATTICDISTFILES_SERVER="://attic-distfiles.pld-linux.org"
cd445739 86
36d03934 87DEF_NICE_LEVEL=19
86aafdbe 88SCHEDTOOL="auto"
cd445739
AM
89
90FAIL_IF_NO_SOURCES="yes"
91
18e5347d
ER
92# let get_files skip over files which are present to get those damn files fetched
93SKIP_EXISTING_FILES="no"
94
975d7b23 95TRY_UPGRADE=""
257af81b
ER
96# should the specfile be restored if upgrade failed?
97REVERT_BROKEN_UPGRADE="yes"
98
ab4a2b6e 99if [ -x /usr/bin/rpm-getdeps ]; then
ce40491a 100 FETCH_BUILD_REQUIRES_RPMGETDEPS="yes"
ab4a2b6e 101else
ce40491a 102 FETCH_BUILD_REQUIRES_RPMGETDEPS="no"
ab4a2b6e
ER
103fi
104
cd445739
AM
105# Here we load saved user environment used to
106# predefine options set above, or passed to builder
107# in command line.
108# This one reads global system environment settings:
109if [ -f ~/etc/builderrc ]; then
110 . ~/etc/builderrc
111fi
112# And this one cascades settings using user personal
113# builder settings.
114# Example of ~/.builderrc:
115#
116#UPDATE_POLDEK_INDEXES="yes"
117#FETCH_BUILD_REQUIRES="yes"
118#REMOVE_BUILD_REQUIRES="force"
119#GROUP_BCONDS="yes"
120#LOGFILE='../LOGS/log.$PACKAGE_NAME.$DATE'
982e358c 121#TITLECHANGE=no
cd445739 122#
a83e5405 123SU_SUDO=""
cd445739
AM
124if [ -n "$HOME_ETC" ]; then
125 USER_CFG="$HOME_ETC/.builderrc"
126else
127 USER_CFG=~/.builderrc
128fi
129
130[ -f "$USER_CFG" ] && . "$USER_CFG"
131
86aafdbe
ER
132if [ "$SCHEDTOOL" = "auto" ]; then
133 if [ -x /usr/bin/schedtool ] && schedtool -B -e echo >/dev/null; then
134 SCHEDTOOL="schedtool -B -e"
135 else
136 SCHEDTOOL="no"
137 fi
138fi
139
ca2e6c31 140if [ -n "$USE_PROZILLA" ]; then
7e365483
KK
141 GETURI="proz --no-getch -r -P ./ -t$WGET_RETRIES $PROZILLA_OPTS"
142 GETURI2="$GETURI"
143 OUTFILEOPT="-O"
ca2e6c31 144elif [ -n "$USE_AXEL" ]; then
cede92b3 145 GETURI="axel -a $AXEL_OPTS"
7e365483
KK
146 GETURI2="$GETURI"
147 OUTFILEOPT="-o"
ca2e6c31 148else
5700ee32
ER
149 wget --help 2>&1 | grep -q -- ' --no-check-certificate ' && WGET_OPTS="$WGET_OPTS --no-check-certificate"
150 wget --help 2>&1 | grep -q -- ' --inet ' && WGET_OPTS="$WGET_OPTS --inet"
151 wget --help 2>&1 | grep -q -- ' --retry-connrefused ' && WGET_OPTS="$WGET_OPTS --retry-connrefused"
6f9a5d76 152
7e365483
KK
153 GETURI="wget --passive-ftp -c -nd -t$WGET_RETRIES $WGET_OPTS"
154 GETURI2="wget -c -nd -t$WGET_RETRIES $WGET_OPTS"
155 OUTFILEOPT="-O"
2bc5451f 156fi
11468b23 157
11468b23
AM
158GETLOCAL="cp -a"
159
160if (rpm --version 2>&1 | grep -q '4.0.[0-2]'); then
161 RPM="rpm"
162 RPMBUILD="rpm"
163else
164 RPM="rpm"
165 RPMBUILD="rpmbuild"
166fi
167
168POLDEK_INDEX_DIR="`$RPM --eval %_rpmdir`/"
a83e5405 169POLDEK_CMD="$SU_SUDO /usr/bin/poldek --noask"
11468b23 170
cd445739
AM
171run_poldek()
172{
173 RES_FILE=~/tmp/poldek-exit-status.$RANDOM
174 if [ -n "$LOGFILE" ]; then
175 LOG=`eval echo $LOGFILE`
176 if [ -n "$LASTLOG_FILE" ]; then
177 echo "LASTLOG=$LOG" > $LASTLOG_FILE
178 fi
86aafdbe 179 (${NICE_COMMAND} ${POLDEK_CMD} `while test $# -gt 0; do echo "$1 ";shift;done` ; echo $? > ${RES_FILE})|tee -a $LOG
cd445739
AM
180 return $exit_pldk
181 else
86aafdbe 182 (${NICE_COMMAND} ${POLDEK_CMD} `while test $# -gt 0; do echo "$1 ";shift;done` ; echo $? > ${RES_FILE}) 1>&2 >/dev/null
cd445739
AM
183 return `cat ${RES_FILE}`
184 rm -rf ${RES_FILE}
185 fi
186}
187
cd445739
AM
188#---------------------------------------------
189# functions
da946cd6 190
5a491465 191usage()
192{
cd445739
AM
193 if [ -n "$DEBUG" ]; then set -xv; fi
194 echo "\
195Usage: builder [-D|--debug] [-V|--version] [-a|--as_anon] [-b|-ba|--build]
cd445739 196[-bb|--build-binary] [-bs|--build-source] [-u|--try-upgrade]
4efa0b98 197[{-cf|--cvs-force}] [{-B|--branch} <branch>] [{-d|--cvsroot} <cvsroot>]
19dc5591 198[-g|--get] [-h|--help] [--http] [{-l|--logtofile} <logfile>] [-m|--mr-proper]
199[-q|--quiet] [--date <yyyy-mm-dd> [-r <cvstag>] [{-T|--tag <cvstag>]
a7b2951c 200[-Tvs|--tag-version-stable] [-Ts|--tag-stable] [-Tv|--tag-version]
cd445739 201[{-Tp|--tag-prefix} <prefix>] [{-tt|--test-tag}]
dfe2cb9a 202[-nu|--no-urls] [-v|--verbose] [--opts <rpm opts>] [--show-bconds]
f19103b5 203[--with/--without <feature>] [--define <macro> <value>] <package>[.spec][:cvstag]
2a5f078d 204
cd445739
AM
205-5, --update-md5 - update md5 comments in spec, implies -nd -ncs
206-a5, --add-md5 - add md5 comments to URL sources, implies -nc -nd -ncs
207-n5, --no-md5 - ignore md5 comments in spec
9243e80b
ER
208-D, --debug - enable builder script debugging mode,
209-debug - produce rpm debug package (same as --opts -debug)
cd445739
AM
210-V, --version - output builder version
211-a, --as_anon - get files via pserver as cvs@$CVS_SERVER,
212-b, -ba, --build - get all files from CVS repo or HTTP/FTP and build package
213 from <package>.spec,
214-bb, --build-binary - get all files from CVS repo or HTTP/FTP and build binary
215 only package from <package>.spec,
c56807e0
ER
216-bp, --build-prep - execute the %prep phase of <package>.spec,
217-bc - reserved (not implemented)
218-bi reserved (not implemented)
cd445739
AM
219-bs, --build-source - get all files from CVS repo or HTTP/FTP and only pack
220 them into src.rpm,
c56807e0 221--short-circuit - reserved (not implemented)
cd445739
AM
222-B, --branch - add branch
223-c, --clean - clean all temporarily created files (in BUILD, SOURCES,
224 SPECS and \$RPM_BUILD_ROOT),
39dcc7de 225-cf, --cvs-force - use -F when tagging (useful when moving branches)
2a5f078d 226-d <cvsroot>, --cvsroot <cvsroot>
cd445739
AM
227 - setup \$CVSROOT,
228--define <macro> <value>
229 - define a macro <macro> with value <value>,
230--nodeps - rpm won't check any dependences
231-g, --get - get <package>.spec and all related files from CVS repo
232 or HTTP/FTP,
233-h, --help - this message,
234--http - use http instead of ftp,
235-l <logfile>, --logtofile <logfile>
236 - log all to file,
237-m, --mr-proper - only remove all files related to spec file and all work
238 resources,
239-nc, --no-cvs - don't download sources from CVS, if source URL is given,
240-ncs, --no-cvs-specs
241 - don't check specs in CVS
242-nd, --no-distfiles - don't download from distfiles
243-nm, --no-mirrors - don't download from mirror, if source URL is given,
244-nu, --no-urls - don't try to download from FTP/HTTP location,
245-ns, --no-srcs - don't download Sources
246-ns0, --no-source0 - don't download Source0
247-nn, --no-net - don't download anything from the net
b572253e 248--no-init - don't initialize builder paths (SPECS and SOURCES)
18e5347d
ER
249-ske,
250--skip-existing-files - skip existing files in get_files
cd445739
AM
251--opts <rpm opts> - additional options for rpm
252-q, --quiet - be quiet,
253--date yyyy-mm-dd - build package using resources from specified CVS date,
254-r <cvstag>, --cvstag <cvstag>
255 - build package using resources from specified CVS tag,
5323fffd 256-A - build package using CVS resources as any sticky tags/date/kopts being reset.
cd445739
AM
257-R, --fetch-build-requires
258 - fetch what is BuildRequired,
259-RB, --remove-build-requires
260 - remove all you fetched with -R or --fetch-build-requires
261 remember, this option requires confirmation,
262-FRB, --force-remove-build-requires
263 - remove all you fetched with -R or --fetch-build-requires
264 remember, this option works without confirmation,
06541433
JR
265-sd, --source-distfiles - list sources available from distfiles (intended for offline
266 operations; does not work when Icon field is present
267 but icon file is absent),
268-sdp, --source-distfiles-paths - list sources available from distfiles -
269 paths relative to distfiles directory (intended for offline
270 operations; does not work when Icon field is present
271 but icon file is absent),
a7eefc54 272-sf, --source-files - list sources - bare filenames (intended for offline
273 operations; does not work when Icon field is present
3621e588 274 but icon file is absent),
a7eefc54 275-sp, --source-paths - list sources - filenames with full local paths (intended for
276 offline operations; does not work when Icon field is present
3621e588 277 but icon file is absent),
2dddf439
ER
278-su, --source-urls - list urls - urls to sources and patches
279 intended for copying urls with spec with lots of macros in urls
cd445739
AM
280-T <cvstag> , --tag <cvstag>
281 - add cvs tag <cvstag> for files,
282-Tvs, --tag-version-stable
094bd95b 283 - add cvs tags STABLE and NAME-VERSION-RELEASE for files,
cd445739
AM
284-Ts, --tag-stable
285 - add cvs tag STABLE for files,
cd445739 286-Tv, --tag-version
1691a37b 287 - add cvs tag NAME-VERSION-RELEASE for files,
cd445739
AM
288-Tp, --tag-prefix <prefix>
289 - add <prefix> to NAME-VERSION-RELEASE tags,
290-tt, --test-tag <prefix>
291 - fail if tag is already present,
50321881
JK
292-ir, --integer-release-only
293 - allow only integer and snapshot releases
cd445739
AM
294-v, --verbose - be verbose,
295-u, --try-upgrade - check version, and try to upgrade package
296-un, --try-upgrade-with-float-version
297 - as above, but allow float version
deccc50e 298-U, --update - refetch sources, don't use distfiles, and update md5 comments
cd445739
AM
299-Upi, --update-poldek-indexes
300 - refresh or make poldek package index files.
c890b916 301-np, --nopatch <patchnumber>
bed98670 302 - don't apply <patchnumber>
dfe2cb9a
MK
303--show-bconds - show available conditional builds, which can be used
304 - with --with and/or --without switches.
9b78be50
ER
305--show-bcond-args - show active bconds, from ~/.bcondrc. this is used by
306 ./repackage.sh script. in other words, the output is
307 parseable by scripts.
cd445739
AM
308--with/--without <feature>
309 - conditional build package depending on %_with_<feature>/
310 %_without_<feature> macro switch. You may now use
311 --with feat1 feat2 feat3 --without feat4 feat5 --with feat6
312 constructions. Set GROUP_BCONDS to yes to make use of it.
6dd19291 313--target <platform>, --target=<platform>
3621e588
ER
314 - build for platform <platform>.
315--init-rpm-dir - initialize ~/rpm directory structure
5a491465 316"
317}
318
c890b916 319update_shell_title() {
a0d6396b 320 [ -t 1 ] || return
0b65d15e
ER
321 local len=${COLUMNS:-80}
322 local msg=$(echo "$*" | cut -c-$len)
323
e225de91
ER
324 if [ -n "$BE_VERBOSE" ]; then
325 echo >&2 "$(date +%s.%N) $*"
326 fi
327
982e358c 328 if [ "x$TITLECHANGE" == "xyes" -o "x$TITLECHANGE" == "x" ]; then
138bbc98
ER
329 local pkg
330 if [ -n "$PACKAGE_NAME" ]; then
331 pkg=${PACKAGE_NAME}-${PACKAGE_VERSION}-${PACKAGE_RELEASE}
332 else
333 pkg=${SPECFILE}
334 fi
335
336 msg="$pkg: ${SHELL_TITLE_PREFIX:+$SHELL_TITLE_PREFIX }$msg"
10c1e115 337 msg="$(echo $msg | tr -d '\n\r')"
982e358c
MP
338 case "$TERM" in
339 cygwin|xterm*)
340 echo >&2 -ne "\033]1;$msg\007\033]2;$msg\007"
341 ;;
342 screen*)
343 echo >&2 -ne "\033]0;$msg\007"
344 ;;
345 esac
346 fi
c890b916
ER
347}
348
7e40520f
ER
349# set TARGET from BuildArch: from SPECFILE
350set_spec_target() {
ce40491a
ER
351 if [ -n "$SPECFILE" ] && [ -z "$TARGET" ]; then
352 tmp=$(awk '/^BuildArch:/ { print $NF}' $SPECFILE)
353 if [ "$tmp" ]; then
7e40520f
ER
354 TARGET="$tmp"
355 case "$RPMBUILD" in
356 "rpmbuild")
ce40491a 357 TARGET_SWITCH="--target $TARGET" ;;
7e40520f 358 "rpm")
ce40491a 359 TARGET_SWITCH="--target=$TARGET" ;;
7e40520f 360 esac
ce40491a
ER
361 fi
362 fi
7e40520f
ER
363}
364
cd445739 365cache_rpm_dump () {
d22150da 366 if [ -n "$DEBUG" ]; then
518ff1fb
ER
367 set -x
368 set -v
d22150da 369 fi
7e40520f 370
13974367 371 update_shell_title "cache_rpm_dump"
237bd3f1
ER
372 local rpm_dump
373 rpm_dump=`
d05e8080 374
fa4bf1df 375 # we reset macros not to contain macros.build as all the %() macros are
559d511f 376 # executed here, while none of them are actually needed.
fa4bf1df 377 # what we need from dump is NAME, VERSION, RELEASE and PATCHES/SOURCES.
559d511f 378 # at the time of this writing macros.build + macros contained 70 "%(...)" macros.
36433112 379 macrofiles="/usr/lib/rpm/macros:$SPECS_DIR/.builder-rpmmacros:~/etc/.rpmmacros:~/.rpmmacros"
237bd3f1 380 dump='%{echo:dummy: PACKAGE_NAME %{name} }%dump'
7cb24972 381 # FIXME: better ideas than .rpmrc?
36433112 382 printf 'include:/usr/lib/rpm/rpmrc\nmacrofiles:%s\n' $macrofiles > .builder-rpmrc
fb198857 383# TODO: move these to /usr/lib/rpm/macros
36433112 384 cat > .builder-rpmmacros <<'EOF'
fb198857
ER
385%requires_releq_kernel_up %{nil}
386%requires_releq_kernel_smp %{nil}
6b8134e3 387%requires_releq() %{nil}
bb01dee9 388%pyrequires_eq() %{nil}
559d511f 389%requires_eq() %{nil}
c13be3d1 390%requires_eq_to() %{nil}
fb198857
ER
391%releq_kernel_up ERROR
392%releq_kernel_smp ERROR
74d9fd14 393%kgcc_package ERROR
237bd3f1 394%_fontsdir ERROR
7141278d 395%ruby_version ERROR
396%ruby_ver_requires_eq() %{nil}
397%ruby_mod_ver_requires_eq() %{nil}
c13be3d1 398%__php_api_requires() %{nil}
7141278d 399%php_major_version ERROR
400%php_api_version ERROR
401%py_ver ERROR
41035426
ER
402%perl_vendorarch ERROR
403%perl_vendorlib ERROR
eb6d9db8 404%patchset_source() %{nil}
fb198857 405EOF
cd445739 406 case "$RPMBUILD" in
237bd3f1
ER
407 rpm)
408 ARGS='-bp'
409 ;;
410 rpmbuild)
411 ARGS='--nodigest --nosignature --nobuild'
412 ;;
413 esac
3d12d055
JR
414 if [ "$NOINIT" = "yes" ] ; then
415 cat >> .builder-rpmmacros <<'EOF'
416%_specdir ./
417%_sourcedir ./
418EOF
c039643c
JR
419 fi
420 $RPMBUILD --rcfile .builder-rpmrc $ARGS $ARGDIRS --nodeps --define "prep $dump" $BCOND $TARGET_SWITCH $SPECFILE 2>&1
237bd3f1 421 `
fb198857 422 if [ $? -gt 0 ]; then
237bd3f1
ER
423 error=$(echo "$rpm_dump" | sed -ne '/^error:/,$p')
424 echo "$error" >&2
518ff1fb 425 Exit_error err_build_fail
fb198857 426 fi
d05e8080
ER
427
428 # make small dump cache
429 rpm_dump_cache=`echo "$rpm_dump" | awk '
4e8c3089
ER
430 $2 ~ /^SOURCEURL/ {print}
431 $2 ~ /^PATCHURL/ {print}
432 $2 ~ /^nosource/ {print}
433 $2 ~ /^PACKAGE_/ {print}
d05e8080
ER
434 '`
435
13974367 436 update_shell_title "cache_rpm_dump: OK!"
cd445739
AM
437}
438
439rpm_dump () {
440 if [ -z "$rpm_dump_cache" ] ; then
d7b4d36e 441 echo "internal error: cache_rpm_dump not called! (missing %prep?)" 1>&2
cd445739
AM
442 fi
443 echo "$rpm_dump_cache"
444}
445
d05e8080
ER
446get_icons()
447{
448 update_shell_title "get icons"
449 ICONS="`awk '/^Icon:/ {print $2}' ${SPECFILE}`"
450 if [ -z "$ICONS" ]; then
451 return
452 fi
453
975d7b23 454 rpm_dump_cache="kalasaba" NODIST="yes" get_files $ICONS
d05e8080
ER
455}
456
59398507 457parse_spec()
458{
af4d5315 459 update_shell_title "parsing specfile"
cd445739 460 if [ -n "$DEBUG" ]; then
518ff1fb
ER
461 set -x
462 set -v
cd445739 463 fi
b2975fc3 464
d05e8080 465 # icons are needed for successful spec parse
518ff1fb 466 get_icons
d05e8080 467
cd445739 468 cd $SPECS_DIR
cd445739 469 cache_rpm_dump
00fcec7e 470
cd445739
AM
471 if [ "$NOSRCS" != "yes" ]; then
472 SOURCES="`rpm_dump | awk '/SOURCEURL[0-9]+/ {print $3}'`"
473 fi
7cb24972 474
cd445739
AM
475 if (rpm_dump | grep -qEi ":.*nosource.*1"); then
476 FAIL_IF_NO_SOURCES="no"
477 fi
478
479 PATCHES="`rpm_dump | awk '/PATCHURL[0-9]+/ {print $3}'`"
480 ICONS="`awk '/^Icon:/ {print $2}' ${SPECFILE}`"
fa4bf1df
ER
481 PACKAGE_NAME=$(rpm_dump | awk '$2 == "PACKAGE_NAME" { print $3}')
482 PACKAGE_VERSION=$(rpm_dump | awk '$2 == "PACKAGE_VERSION" { print $3}')
483 PACKAGE_RELEASE=$(rpm_dump | awk '$2 == "PACKAGE_RELEASE" { print $3}')
78eab2a1 484
cd445739
AM
485 if [ -n "$BE_VERBOSE" ]; then
486 echo "- Sources : `nourl $SOURCES`"
487 if [ -n "$PATCHES" ]; then
488 echo "- Patches : `nourl $PATCHES`"
489 else
490 echo "- Patches : *no patches needed*"
491 fi
492 if [ -n "$ICONS" ]; then
493 echo "- Icon : `nourl $ICONS`"
494 else
495 echo "- Icon : *no package icon*"
496 fi
497 echo "- Name : $PACKAGE_NAME"
498 echo "- Version : $PACKAGE_VERSION"
499 echo "- Release : $PACKAGE_RELEASE"
500 fi
13974367
ER
501
502 update_shell_title "parse_spec: OK!"
cd445739
AM
503}
504
505Exit_error()
506{
507 if [ -n "$DEBUG" ]; then
518ff1fb
ER
508 set -x
509 set -v
cd445739
AM
510 fi
511
512 cd "$__PWD"
513
514 case "$1" in
515 "err_no_spec_in_cmdl" )
516 remove_build_requires
518ff1fb 517 echo "ERROR: spec file name not specified."
cd445739
AM
518 exit 2 ;;
519 "err_no_spec_in_repo" )
520 remove_build_requires
518ff1fb 521 echo "Error: spec file not stored in CVS repo."
cd445739
AM
522 exit 3 ;;
523 "err_no_source_in_repo" )
524 remove_build_requires
518ff1fb 525 echo "Error: some source, patch or icon files not stored in CVS repo. ($2)"
cd445739
AM
526 exit 4 ;;
527 "err_build_fail" )
528 remove_build_requires
518ff1fb 529 echo "Error: package build failed. (${2:-no more info})"
cd445739 530 exit 5 ;;
78eab2a1
AM
531 "err_no_package_data" )
532 remove_build_requires
533 echo "Error: couldn't get out package name/version/release from spec file."
534 exit 6 ;;
ce40491a 535 "err_tag_exists" )
50321881 536 remove_build_requires
518ff1fb 537 echo "Tag ${2} already exists (spec release: ${3})."
50321881 538 exit 9 ;;
ce40491a 539 "err_fract_rel" )
50321881 540 remove_build_requires
518ff1fb 541 echo "Release ${2} not integer and not a snapshot."
50321881 542 exit 10 ;;
fb96e0b5
AM
543 "err_branch_exists" )
544 remove_build_requires
518ff1fb 545 echo "Tree branch already exists (${2})."
fb96e0b5 546 exit 11 ;;
50321881 547
cd445739 548 esac
73848362
ER
549 echo "Unknown error."
550 exit 100
cd445739
AM
551}
552
553init_builder()
554{
555 if [ -n "$DEBUG" ]; then
518ff1fb
ER
556 set -x
557 set -v
0dd6320d 558 fi
cd445739 559
4aeb9973 560 if [ "$NOINIT" != "yes" ] ; then
29e90b02
JR
561 SOURCE_DIR="`eval $RPM $RPMOPTS --eval '%{_sourcedir}'`"
562 SPECS_DIR="`eval $RPM $RPMOPTS --eval '%{_specdir}'`"
563 else
564 SOURCE_DIR="."
565 SPECS_DIR="."
566 fi
cd445739
AM
567
568 __PWD="`pwd`"
00fcec7e 569}
570
d6a77ddb 571get_spec()
1471f6d6 572{
c890b916 573
2e5be021 574 update_shell_title "get_spec"
c890b916 575
cd445739 576 if [ -n "$DEBUG" ]; then
518ff1fb
ER
577 set -x
578 set -v
cd445739
AM
579 fi
580
581 cd "$SPECS_DIR"
049ab214 582 if [ ! -f "$SPECFILE" ]; then
518ff1fb 583 SPECFILE="`basename $SPECFILE .spec`.spec"
cd445739
AM
584 fi
585 if [ "$NOCVSSPEC" != "yes" ]; then
cd445739 586
049ab214
ER
587 if [ ! -s CVS/Root -a "$NOCVSSPEC" != "yes" ]; then
588 echo "Warning: No CVS access defined - using local .spec file"
589 NOCVSSPEC="yes"
cd445739
AM
590 fi
591
049ab214 592 cvsup "$SPECFILE" || Exit_error err_no_spec_in_repo
cd445739 593 fi
049ab214 594
cd445739 595 if [ ! -f "$SPECFILE" ]; then
518ff1fb 596 Exit_error err_no_spec_in_repo
cd445739
AM
597 fi
598
599 if [ "$CHMOD" = "yes" -a -n "$SPECFILE" ]; then
600 chmod $CHMOD_MODE $SPECFILE
601 fi
602 unset OPTIONS
a7eefc54 603 [ -n "$DONT_PRINT_REVISION" ] || grep -E -m 1 "^#.*Revision:.*Date" $SPECFILE
7e40520f 604
ce40491a 605 set_spec_target
cd445739
AM
606}
607
608find_mirror()
609{
610 cd "$SPECS_DIR"
782518da 611 local url="$1"
cd445739
AM
612 if [ ! -f "mirrors" -a "$NOCVSSPEC" != "yes" ] ; then
613 cvs update mirrors >&2
614 fi
615
616 IFS="|"
782518da
ER
617 local origin mirror name rest ol prefix
618 while read origin mirror name rest; do
619 # skip comments and empty lines
620 if [ -z "$origin" ] || [[ $origin == \#* ]]; then
621 continue
622 fi
cd445739
AM
623 ol=`echo -n "$origin"|wc -c`
624 prefix="`echo -n "$url" | head -c $ol`"
625 if [ "$prefix" = "$origin" ] ; then
782518da 626 suffix="`echo "$url"|cut -b $((ol+1))-`"
cd445739
AM
627 echo -n "$mirror$suffix"
628 return 0
629 fi
630 done < mirrors
631 echo "$url"
632}
633
e7e0d4ec 634# Warning: unpredictable results if same URL used twice
cd445739
AM
635src_no ()
636{
637 cd $SPECS_DIR
638 rpm_dump | \
639 grep "SOURCEURL[0-9]*[ ]*$1""[ ]*$" | \
640 sed -e 's/.*SOURCEURL\([0-9][0-9]*\).*/\1/' | \
641 head -n 1 | xargs
1471f6d6 642}
643
e7e0d4ec 644src_md5()
8ba5cdda 645{
e7e0d4ec 646 [ "$NO5" = "yes" ] && return
cd445739
AM
647 no=$(src_no "$1")
648 [ -z "$no" ] && return
649 cd $SPECS_DIR
e7e0d4ec
ER
650 local md5
651
652 if [ -f additional-md5sums ]; then
653 local spec_rev=$(grep $SPECFILE CVS/Entries 2>/dev/null | sed -e s:/$SPECFILE/:: -e s:/.*::)
654 if [ -z "$spec_rev" ]; then
655 spec_rev="$(head -n 1 $SPECFILE | sed -e 's/.*\$Revision: \([0-9.]*\).*/\1/')"
656 fi
657 local spec="$SPECFILE[0-9.,]*,$(echo $spec_rev | sed 's/\./\\./g')"
658 md5=$(grep -s -v '^#' additional-md5sums | \
659 grep -E "[ ]$(basename "$1")[ ]+${spec}([ ,]|\$)" | \
660 sed -e 's/^\([0-9a-f]\{32\}\).*/\1/' | \
661 grep -E '^[0-9a-f]{32}$')
662
663 if [ "$md5" ]; then
664 if [ $(echo "$md5" | wc -l) != 1 ] ; then
665 echo "$SPECFILE: more then one entry in additional-md5sums for $1" 1>&2
666 fi
667 echo "$md5" | tail -n 1
668 return
669 fi
cd445739 670 fi
e7e0d4ec
ER
671
672 source_md5=`grep -i "#[ ]*Source$no-md5[ ]*:" $SPECFILE | sed -e 's/.*://'`
673 if [ -n "$source_md5" ]; then
674 echo $source_md5
cd445739 675 else
e7e0d4ec
ER
676 # we have empty SourceX-md5, but it is still possible
677 # that we have NoSourceX-md5 AND NoSource: X
678 nosource_md5=`grep -i "#[ ]*NoSource$no-md5[ ]*:" $SPECFILE | sed -e 's/.*://'`
03db3356 679 if [ -n "$nosource_md5" -a -n "`grep -i "^NoSource:[ ]*$no$" $SPECFILE`" ] ; then
e7e0d4ec 680 echo $nosource_md5
cd445739 681 fi
cd445739
AM
682 fi
683}
684
06541433
JR
685distfiles_path ()
686{
687 echo "by-md5/$(src_md5 "$1" | sed -e 's|^\(.\)\(.\)|\1/\2/&|')/$(basename "$1")"
688}
689
cd445739
AM
690distfiles_url ()
691{
06541433 692 echo "$PROTOCOL$DISTFILES_SERVER/distfiles/$(distfiles_path "$1")"
cd445739
AM
693}
694
695distfiles_attic_url ()
696{
06541433 697 echo "$PROTOCOL$ATTICDISTFILES_SERVER/distfiles/Attic/$(distfiles_path "$1")"
cd445739
AM
698}
699
700good_md5 ()
701{
702 md5=$(src_md5 "$1")
703 [ "$md5" = "" ] || \
704 [ "$md5" = "$(md5sum $(nourl "$1") 2> /dev/null | sed -e 's/ .*//')" ]
8ba5cdda
PG
705}
706
a4b50627
AF
707good_size ()
708{
ce40491a
ER
709 size="$(find $(nourl "$1") -printf "%s" 2>/dev/null)"
710 [ -n "$size" -a "$size" -gt 0 ]
a4b50627
AF
711}
712
947025e5 713cvsignore_df ()
714{
715 if [ "$CVSIGNORE_DF" != "yes" ]; then
716 return
717 fi
718 cvsignore=${SOURCE_DIR}/.cvsignore
719 if ! grep -q "^$1\$" $cvsignore 2> /dev/null; then
720 echo "$1" >> $cvsignore
721 fi
722}
723
e7fa3b9f
ER
724cvsup()
725{
ce40491a
ER
726 update_shell_title "cvsup"
727 local OPTIONS="up "
728 if [ -n "$CVSROOT" ]; then
729 OPTIONS="-d $CVSROOT $OPTIONS"
730 fi
b1c6aace 731
ce40491a
ER
732 if [ -z "$CVSDATE" -a -z "$CVSTAG" ]; then
733 OPTIONS="$OPTIONS -A"
734 else
735 if [ -n "$CVSDATE" ]; then
736 OPTIONS="$OPTIONS -D $CVSDATE"
737 fi
738 if [ -n "$CVSTAG" ]; then
739 OPTIONS="$OPTIONS -r $CVSTAG"
740 fi
741 fi
e7fa3b9f 742
ce40491a
ER
743 local result=1
744 local retries_counter=0
745 if [ $# = 1 ]; then
746 update_shell_title "cvsup: $*"
747 else
748 update_shell_title "cvsup: $# files"
749 fi
750 while [ "$result" != "0" -a "$retries_counter" -le "$CVS_RETRIES" ]; do
751 retries_counter=$(( $retries_counter + 1 ))
752 output=$(LC_ALL=C cvs $OPTIONS "$@" 2>&1)
753 result=$?
754 [ -n "$output" ] && echo "$output"
755 if (echo "$output" | grep -qE "(Cannot connect to|connect to .* failed|Connection reset by peer|Connection timed out|Unknown host)") && [ "$result" -ne "0" -a "$retries_counter" -le "$CVS_RETRIES" ]; then
756 echo "Trying again [$*]... ($retries_counter)"
757 update_shell_title "cvsup: retry #$retries_counter"
758 sleep 2
759 continue
760 else
761 break
762 fi
763 done
764 update_shell_title "cvsup: done!"
765 return $result
e7fa3b9f
ER
766}
767
71f8e908
ER
768# returns true if "$1" is ftp, http or https protocol url
769is_url()
770{
771 case "$1" in
772 ftp://*|http://*|https://*)
773 return 0
774 ;;
775 esac
776 return 1
777}
778
ecba6ad5
ER
779update_md5()
780{
781 if [ $# -eq 0 ]; then
782 return
783 fi
784
785 update_shell_title "update md5"
786 if [ -n "$DEBUG" ]; then
518ff1fb
ER
787 set -x
788 set -v
ecba6ad5
ER
789 fi
790
791 cd "$SOURCE_DIR"
792
793 # pass 1: check files to be fetched
794 local todo
795 local need_files
796 for i in "$@"; do
797 local fp=$(nourl "$i")
798 local srcno=$(src_no "$i")
6392b5fd
ER
799 if [ -n "$ADD5" ]; then
800 [ "$fp" = "$i" ] && continue # FIXME what is this check doing?
801 grep -qiE '^#[ ]*Source'$srcno'-md5[ ]*:' $SPECS_DIR/$SPECFILE && continue
802 else
803 grep -qiE '^#[ ]*Source'$srcno'-md5[ ]*:' $SPECS_DIR/$SPECFILE || continue
ecba6ad5
ER
804 fi
805 if [ ! -f "$fp" ] || [ $ALWAYS_CVSUP = "yes" ]; then
806 need_files="$need_files $i"
807 fi
808 done
809
810 # pass 1a: get needed files
811 if [ "$need_files" ]; then
812 get_files $need_files
813 fi
814
815 # pass 2: proceed with md5 adding or updating
816 for i in "$@"; do
817 local fp=$(nourl "$i")
818 local srcno=$(src_no "$i")
71f8e908
ER
819 local md5=$(grep -iE '^#[ ]*(No)?Source'$srcno'-md5[ ]*:' $SPECS_DIR/$SPECFILE )
820 if [ -n "$ADD5" ] && is_url $i || [ -n "$md5" ]; then
821 local tag="Source$srcno-md5"
822 if [[ "$md5" == *NoSource* ]]; then
823 tag="NoSource$srcno-md5"
824 fi
ecba6ad5 825 md5=$(md5sum "$fp" | cut -f1 -d' ')
4efa0b98 826 echo "Updating $tag ($md5: $fp)."
ecba6ad5 827 perl -i -ne '
71f8e908
ER
828 print unless /^\s*#\s*(No)?Source'$srcno'-md5\s*:/i;
829 print "# '$tag':\t'$md5'\n" if /^Source'$srcno'\s*:\s+/;
ecba6ad5
ER
830 ' \
831 $SPECS_DIR/$SPECFILE
832 fi
833 done
834}
835
836check_md5()
837{
838 update_shell_title "check md5"
839
840 for i in "$@"; do
841 if good_md5 "$i" && good_size "$i"; then
842 continue
843 fi
844
845 echo "MD5 sum mismatch or 0 size. Use -U to refetch sources,"
846 echo "or -5 to update md5 sums, if you're sure files are correct."
847 Exit_error err_no_source_in_repo $i
848 done
849}
850
cd445739
AM
851get_files()
852{
7cb24972 853 update_shell_title "get_files"
cd445739
AM
854
855 if [ -n "$DEBUG" ]; then
518ff1fb
ER
856 set -x
857 set -v
cd445739
AM
858 fi
859
f09c0772 860 if [ $# -gt 0 ]; then
cd445739
AM
861 cd "$SOURCE_DIR"
862
b1c6aace 863 if [ ! -s CVS/Root -a "$NOCVS" != "yes" ]; then
049ab214 864 echo "Warning: No CVS access defined for SOURCES"
b1c6aace
ER
865 NOCVS="yes"
866 fi
867
f2e42a41 868 local nc=0
e7fa3b9f 869 local get_files_cvs=""
3815b69a 870 for i in "$@"; do
f2e42a41 871 nc=$((nc + 1))
dcebdffb 872 local cvsup=0
3815b69a 873 SHELL_TITLE_PREFIX="get_files[$nc/$#]"
f2e42a41 874 update_shell_title "$i"
f09c0772 875 local fp=`nourl "$i"`
ecba6ad5 876 if [ "$SKIP_EXISTING_FILES" = "yes" ] && [ -f "$fp" ]; then
ce40491a 877 continue
18e5347d 878 fi
ecba6ad5 879
cd445739 880 FROM_DISTFILES=0
e7e0d4ec 881 local srcmd5=$(src_md5 "$i")
ecba6ad5
ER
882
883 # we know if source/patch is present in cvs/distfiles
884 # - has md5 (in distfiles)
885 # - in cvs... ideas?
886
887 # CHECK: local file didn't exist or always cvs up (first) requested.
f09c0772 888 if [ ! -f "$fp" ] || [ $ALWAYS_CVSUP = "yes" ]; then
cd445739
AM
889 if echo $i | grep -vE '(http|ftp|https|cvs|svn)://' | grep -qE '\.(gz|bz2)$']; then
890 echo "Warning: no URL given for $i"
891 fi
892
e7e0d4ec 893 if [ -z "$NODIST" ] && [ -n "$srcmd5" ]; then
a4b50627 894 if good_md5 "$i" && good_size "$i"; then
e7e0d4ec 895 echo "$fp having proper md5sum already exists"
cd445739
AM
896 continue
897 fi
4ea1c265 898 target="$fp"
28b34560
ER
899
900 # prefer mirror over distfiles if there's mirror
901 # TODO: build url list and then try each url from the list
902 if [ -z "$NOMIRRORS" ] && im=$(find_mirror "$i") && [ "$im" != "$i" ]; then
903 url="$im"
904 else
905 url=$(distfiles_url "$i")
906 fi
907
cd445739
AM
908 url_attic=$(distfiles_attic_url "$i")
909 FROM_DISTFILES=1
ecba6ad5
ER
910 # is $url local file?
911 if [[ "$url" = [./]* ]]; then
18a52930 912 update_shell_title "${GETLOCAL%% *}: $url"
cd445739
AM
913 ${GETLOCAL} $url $target
914 else
915 if [ -z "$NOMIRRORS" ]; then
916 url="`find_mirror "$url"`"
917 fi
18a52930 918 update_shell_title "${GETURI%% *}: $url"
ca2e6c31 919 ${GETURI} ${OUTFILEOPT} "$target" "$url" || \
33da77c4 920 if [ "`echo $url | grep -E 'ftp://'`" ]; then
18a52930 921 update_shell_title "${GETURI2%% *}: $url"
ca2e6c31 922 ${GETURI2} ${OUTFILEOPT} "$target" "$url"
cd445739
AM
923 fi
924 fi
ecba6ad5
ER
925
926 # is it empty file?
927 if [ ! -s "$target" ]; then
cd445739
AM
928 rm -f "$target"
929 if [ `echo $url_attic | grep -E '^(\.|/)'` ]; then
18a52930 930 update_shell_title "${GETLOCAL%% *}: $url_attic"
cd445739
AM
931 ${GETLOCAL} $url_attic $target
932 else
933 if [ -z "$NOMIRRORS" ]; then
934 url_attic="`find_mirror "$url_attic"`"
935 fi
18a52930 936 update_shell_title "${GETURI%% *}: $url_attic"
ca2e6c31 937 ${GETURI} ${OUTFILEOPT} "$target" "$url_attic" || \
33da77c4 938 if [ "`echo $url_attic | grep -E 'ftp://'`" ]; then
ce40491a 939 update_shell_title "${GETURI2%% *}: $url_attic"
ca2e6c31 940 ${GETURI2} ${OUTFILEOPT} "$target" "$url_attic"
cd445739
AM
941 fi
942 fi
943 fi
ecba6ad5
ER
944
945 if [ -s "$target" ]; then
947025e5 946 cvsignore_df $target
947 else
cd445739
AM
948 rm -f "$target"
949 FROM_DISTFILES=0
950 fi
e7e0d4ec 951 elif [ "$NOCVS" != "yes" -a -z "$srcmd5" ]; then
d05e8080
ER
952 if [ $# -gt 1 ]; then
953 get_files_cvs="$get_files_cvs $fp"
954 update_shell_title "$fp (will cvs up later)"
955 cvsup=1
956 else
957 cvsup $fp
958 fi
cd445739
AM
959 fi
960
f09c0772 961 if [ -z "$NOURLS" ] && [ ! -f "$fp" -o -n "$UPDATE" ] && [ "`echo $i | grep -E 'ftp://|http://|https://'`" ]; then
cd445739
AM
962 if [ -z "$NOMIRRORS" ]; then
963 im="`find_mirror "$i"`"
964 else
965 im="$i"
966 fi
ce40491a 967 update_shell_title "${GETURI%% *}: $im"
cd445739 968 ${GETURI} "$im" || \
33da77c4 969 if [ "`echo $im | grep -E 'ftp://'`" ]; then
ce40491a 970 update_shell_title "${GETURI2%% *}: $im"
cd445739 971 ${GETURI2} "$im"
7e365483 972 fi
cd445739
AM
973 fi
974
dcebdffb
ER
975 if [ "$cvsup" = 1 ]; then
976 continue
977 fi
978
cd445739 979 fi
ecba6ad5
ER
980
981 # the md5 check must be moved elsewhere as if we've called from update_md5 the md5 is wrong.
f09c0772 982 if [ ! -f "$fp" -a "$FAIL_IF_NO_SOURCES" != "no" ]; then
518ff1fb 983 Exit_error err_no_source_in_repo $i
cd445739 984 fi
2a5f078d 985
ecba6ad5 986 # we check md5 here just only to refetch immediately
a4b50627 987 if good_md5 "$i" && good_size "$i"; then
cd445739
AM
988 :
989 elif [ "$FROM_DISTFILES" = 1 ]; then
deccc50e 990 # wrong md5 from distfiles: remove the file and try again
cd445739 991 # but only once ...
deccc50e 992 echo "MD5 sum mismatch. Trying full fetch."
cd445739
AM
993 FROM_DISTFILES=2
994 rm -f $target
18a52930 995 update_shell_title "${GETURI%% *}: $url"
ca2e6c31 996 ${GETURI} ${OUTFILEOPT} "$target" "$url" || \
33da77c4 997 if [ "`echo $url | grep -E 'ftp://'`" ]; then
ce40491a 998 update_shell_title "${GETURI2%% *}: $url"
ca2e6c31 999 ${GETURI2} ${OUTFILEOPT} "$target" "$url"
cd445739 1000 fi
ecba6ad5 1001 if [ ! -s "$target" ]; then
cd445739 1002 rm -f "$target"
18a52930 1003 update_shell_title "${GETURI%% *}: $url_attic"
ca2e6c31 1004 ${GETURI} ${OUTFILEOPT} "$target" "$url_attic" || \
33da77c4 1005 if [ "`echo $url_attic | grep -E 'ftp://'`" ]; then
ce40491a 1006 update_shell_title "${GETURI2%% *}: $url_attic"
ca2e6c31 1007 ${GETURI2} ${OUTFILEOPT} "$target" "$url_attic"
cd445739
AM
1008 fi
1009 fi
1010 test -s "$target" || rm -f "$target"
1011 fi
cd445739 1012 done
e7fa3b9f
ER
1013 SHELL_TITLE_PREFIX=""
1014
1015 if [ "$get_files_cvs" ]; then
ce40491a 1016 cvsup $get_files_cvs
e7fa3b9f 1017 fi
cd445739
AM
1018
1019 if [ "$CHMOD" = "yes" ]; then
3815b69a 1020 CHMOD_FILES="`nourl "$@"`"
cd445739
AM
1021 if [ -n "$CHMOD_FILES" ]; then
1022 chmod $CHMOD_MODE $CHMOD_FILES
1023 fi
1024 fi
cd445739
AM
1025 fi
1026}
1027
1028make_tagver() {
ce40491a 1029 if [ -n "$DEBUG" ]; then
518ff1fb
ER
1030 set -x
1031 set -v
ce40491a 1032 fi
78eab2a1 1033
ce40491a
ER
1034 # Check whether first character of PACKAGE_NAME is legal for tag name
1035 if [ -z "${PACKAGE_NAME##[_0-9]*}" -a -z "$TAG_PREFIX" ]; then
1036 TAG_PREFIX=tag_
1037 fi
1038 TAGVER=$TAG_PREFIX$PACKAGE_NAME-`echo $PACKAGE_VERSION | sed -e "s/\./\_/g" -e "s/@/#/g"`-`echo $PACKAGE_RELEASE | sed -e "s/\./\_/g" -e "s/@/#/g"`
1039 # Remove #kernel.version_release from TAGVER because tagging sources
1040 # could occur with different kernel-headers than kernel-headers used at build time.
1041 TAGVER=$(echo "$TAGVER" | sed -e 's/#.*//g')
1042 echo -n "$TAGVER"
cd445739
AM
1043}
1044
1045tag_files()
1046{
1047 TAG_FILES="$@"
1048
1049 if [ -n "$DEBUG" ]; then
518ff1fb
ER
1050 set -x
1051 set -v
cd445739
AM
1052 fi
1053
73ef63d8
ER
1054 echo "Version: $PACKAGE_VERSION"
1055 echo "Release: $PACKAGE_RELEASE"
cd445739 1056
73ef63d8 1057 TAGVER=`make_tagver`
cd445739 1058
73ef63d8
ER
1059 if [ "$TAG_VERSION" = "yes" ]; then
1060 echo "CVS tag: $TAGVER"
1061 fi
1062 if [ -n "$TAG" ]; then
1063 echo "CVS tag: $TAG"
1064 fi
cd445739 1065
39dcc7de 1066 local OPTIONS="tag $CVS_FORCE"
73ef63d8
ER
1067 if [ -n "$CVSROOT" ]; then
1068 OPTIONS="-d $CVSROOT $OPTIONS"
1069 fi
cd445739 1070
73ef63d8
ER
1071 cd "$SOURCE_DIR"
1072 local tag_files
1073 for i in $TAG_FILES; do
1074 # don't tag files stored on distfiles
1075 [ -n "`src_md5 $i`" ] && continue
1076 local fp=`nourl "$i"`
1077 if [ -f "$fp" ]; then
1078 tag_files="$tag_files $fp"
1079 else
1080 Exit_error err_no_source_in_repo $i
03db3356 1081 fi
73ef63d8 1082 done
03db3356 1083
73ef63d8 1084 if [ "$tag_files" ]; then
cd445739 1085 if [ "$TAG_VERSION" = "yes" ]; then
73ef63d8
ER
1086 update_shell_title "tag sources: $TAGVER"
1087 cvs $OPTIONS $TAGVER $tag_files
cd445739
AM
1088 fi
1089 if [ -n "$TAG" ]; then
73ef63d8
ER
1090 update_shell_title "tag sources: $TAG"
1091 cvs $OPTIONS $TAG $tag_files
cd445739 1092 fi
73ef63d8
ER
1093 fi
1094
1095 cd "$SPECS_DIR"
1096 if [ "$TAG_VERSION" = "yes" ]; then
1097 update_shell_title "tag spec: $TAGVER"
1098 cvs $OPTIONS $TAGVER $SPECFILE
1099 fi
1100 if [ -n "$TAG" ]; then
1101 update_shell_title "tag spec: $TAG"
1102 cvs $OPTIONS $TAG $SPECFILE
1103 fi
cd445739
AM
1104}
1105
1106branch_files()
1107{
1108 TAG=$1
1109 echo "CVS branch tag: $TAG"
518ff1fb 1110 shift
cd445739
AM
1111
1112 TAG_FILES="$@"
1113
1114 if [ -n "$DEBUG" ]; then
518ff1fb
ER
1115 set -x
1116 set -v
cd445739
AM
1117 fi
1118
78a5a506
ER
1119 local OPTIONS="tag $CVS_FORCE -b"
1120 if [ -n "$CVSROOT" ]; then
1121 OPTIONS="-d $CVSROOT $OPTIONS"
1122 fi
1123 cd "$SOURCE_DIR"
1124 local tag_files
1125 for i in $TAG_FILES; do
1126 local fp=`nourl "$i"`
1127 if [ -f "$fp" ]; then
1128 tag_files="$tag_files $fp"
1129 else
1130 Exit_error err_no_source_in_repo $i
c10fa4fa 1131 fi
78a5a506
ER
1132 done
1133 if [ "$tag_files" ]; then
1134 cvs $OPTIONS $TAG $tag_files
1135 fi
c10fa4fa 1136
78a5a506
ER
1137 cd "$SPECS_DIR"
1138 cvs $OPTIONS $TAG $SPECFILE
cd445739
AM
1139}
1140
1141
1142
59398507 1143build_package()
1144{
2e5be021 1145 update_shell_title "build_package"
cd445739 1146 if [ -n "$DEBUG" ]; then
518ff1fb
ER
1147 set -x
1148 set -v
cd445739 1149 fi
5a491465 1150
cd445739
AM
1151 cd "$SPECS_DIR"
1152
1153 if [ -n "$TRY_UPGRADE" ]; then
ce40491a 1154 update_shell_title "build_package: try_upgrade"
cd445739 1155 if [ -n "$FLOAT_VERSION" ]; then
cc538c24 1156 TNOTIFY=`./pldnotify.awk $SPECFILE -n` || exit 1
cd445739 1157 else
cc538c24 1158 TNOTIFY=`./pldnotify.awk $SPECFILE` || exit 1
cd445739
AM
1159 fi
1160
1161 TNEWVER=`echo $TNOTIFY | awk '{ match($4,/\[NEW\]/); print $5 }'`
1162
1163 if [ -n "$TNEWVER" ]; then
1164 TOLDVER=`echo $TNOTIFY | awk '{ print $3; }'`
1165 echo "New version found, updating spec file to version " $TNEWVER
257af81b
ER
1166 if [ "$REVERT_BROKEN_UPGRADE" = "yes" ]; then
1167 cp -f $SPECFILE $SPECFILE.bak
1168 fi
cd445739
AM
1169 chmod +w $SPECFILE
1170 eval "perl -pi -e 's/Version:\t"$TOLDVER"/Version:\t"$TNEWVER"/gs' $SPECFILE"
f7b91886 1171 eval "perl -pi -e 's/Release:\t[1-9]{0,4}/Release:\t0.1/' $SPECFILE"
518ff1fb
ER
1172 parse_spec
1173 NODIST="yes" get_files $SOURCES $PATCHES
6392b5fd 1174 update_md5 $SOURCES
975d7b23 1175
cd445739
AM
1176 unset TOLDVER TNEWVER TNOTIFY
1177 fi
1178 fi
1179 cd "$SPECS_DIR"
2a5f078d 1180
cd445739
AM
1181 case "$COMMAND" in
1182 build )
1183 BUILD_SWITCH="-ba" ;;
1184 build-binary )
1185 BUILD_SWITCH="-bb" ;;
1186 build-source )
1187 BUILD_SWITCH="-bs --nodeps" ;;
1188 build-prep )
1189 BUILD_SWITCH="-bp --nodeps" ;;
1190 esac
c890b916 1191
2e5be021 1192 update_shell_title "build_package: $COMMAND"
cd445739
AM
1193 if [ -n "$LOGFILE" ]; then
1194 LOG=`eval echo $LOGFILE`
1195 if [ -d "$LOG" ]; then
1196 echo "Log file $LOG is a directory."
1197 echo "Parse error in the spec?"
518ff1fb 1198 Exit_error err_build_fail
cd445739
AM
1199 fi
1200 if [ -n "$LASTLOG_FILE" ]; then
1201 echo "LASTLOG=$LOG" > $LASTLOG_FILE
1202 fi
1203 RES_FILE=~/tmp/$RPMBUILD-exit-status.$RANDOM
86aafdbe 1204 (time eval ${NICE_COMMAND} $RPMBUILD $BUILD_SWITCH -v $QUIET $CLEAN $RPMOPTS $RPMBUILDOPTS $BCOND $TARGET_SWITCH $SPECFILE; echo $? > $RES_FILE) 2>&1 |tee $LOG
cd445739
AM
1205 RETVAL=`cat $RES_FILE`
1206 rm $RES_FILE
1207 if [ -n "$LOGDIROK" ] && [ -n "$LOGDIRFAIL" ]; then
1208 if [ "$RETVAL" -eq "0" ]; then
1209 mv $LOG $LOGDIROK
1210 else
1211 mv $LOG $LOGDIRFAIL
1212 fi
1213 fi
8ba5cdda 1214 else
86aafdbe 1215 eval ${NICE_COMMAND} $RPMBUILD $BUILD_SWITCH -v $QUIET $CLEAN $RPMOPTS $RPMBUILDOPTS $BCOND $TARGET_SWITCH $SPECFILE
cd445739 1216 RETVAL=$?
8ba5cdda 1217 fi
cd445739
AM
1218 if [ "$RETVAL" -ne "0" ]; then
1219 if [ -n "$TRY_UPGRADE" ]; then
796a8a95 1220 echo "\n!!! Package with new version cannot be built automagically\n"
257af81b
ER
1221 if [ "$REVERT_BROKEN_UPGRADE" = "yes" ]; then
1222 mv -f $SPECFILE.bak $SPECFILE
1223 fi
cd445739 1224 fi
518ff1fb 1225 Exit_error err_build_fail
cd445739
AM
1226 fi
1227 unset BUILD_SWITCH
1228}
1229
1230nourl()
1231{
1232 echo "$@" | sed 's#\<\(ftp\|http\|https\|cvs\|svn\)://[^ ]*/##g'
1233}
1234
cd445739
AM
1235install_required_packages()
1236{
1237 run_poldek -vi $1
1238 return $?
1239}
1240
fa4bf1df
ER
1241find_spec_bcond() {
1242 # taken from find-spec-bcond, but with just getting the list
1243 local SPEC="$1"
1244 # quick revert hint: '$RPMBUILD --bcond $SPEC'
1245 awk -F"\n" '
1246 /^%changelog/ { exit }
1247 /_with(out)?_[_a-zA-Z0-9]+/{
1248 match($0, /_with(out)?_[_a-zA-Z0-9]+/);
1249 print substr($0, RSTART, RLENGTH);
1250 }
1251 /^%bcond_with/{
1252 match($0, /bcond_with(out)?[ \t]+[_a-zA-Z0-9]+/);
1253 bcond = substr($0, RSTART +5 , RLENGTH -5);
1254 gsub(/[ \t]+/,"_",bcond);
1255 print bcond
1256 }' $SPEC | LC_ALL=C sort -u
1257}
1258
117d9861 1259process_bcondrc() {
301cbfd4
ER
1260 # expand bconds from ~/.bcondrc
1261 # The file structure is like gentoo's package.use:
1262 # ---
1263 # * -selinux
1264 # samba -mysql -pgsql
47a8df12 1265 # w32codec-installer license_agreement
301cbfd4
ER
1266 # php +mysqli
1267 # ---
fa4bf1df 1268 if ([ -f $HOME/.bcondrc ] || ([ -n $HOME_ETC ] && [ -f $HOME_ETC/.bcondrc ])); then
117d9861
ER
1269 :
1270 else
1271 return
1272 fi
301cbfd4 1273
117d9861 1274 SN=${SPECFILE%%\.spec}
c8a3e2ac 1275
117d9861
ER
1276 local bcondrc=$HOME/.bcondrc
1277 [ -n $HOME_ETC ] && [ -f $HOME_ETC/.bcondrc ] && bcondrc=$HOME_ETC/.bcondrc
301cbfd4 1278
117d9861 1279 local bcond_avail=$(find_spec_bcond $SPECFILE)
301cbfd4 1280
117d9861
ER
1281 while read pkg flags; do
1282 # ignore comments
1283 [[ "$pkg" == \#* ]] && continue
1284
1285 # any package or current package?
1286 if [ "$pkg" = "*" ] || [ "$pkg" = "$PACKAGE_NAME" ] || [ "$pkg" = "$SN" ]; then
1287 for flag in $flags; do
1288 local opt=${flag#[+-]}
1289
1290 # use only flags which are in this package.
1291 if [[ $bcond_avail = *${opt}* ]]; then
1292 if [[ $flag = -* ]]; then
1293 if [[ $BCOND != *--with?${opt}* ]]; then
1294 BCOND="$BCOND --without $opt"
1295 fi
1296 else
1297 if [[ $BCOND != *--without?${opt}* ]]; then
1298 BCOND="$BCOND --with $opt"
301cbfd4
ER
1299 fi
1300 fi
117d9861
ER
1301 fi
1302 done
1303 fi
1304 done < $bcondrc
1305 update_shell_title "parse ~/.bcondrc: DONE!"
1306}
1307
1308set_bconds_values()
1309{
1310 update_shell_title "set bcond values"
1311
1312 AVAIL_BCONDS_WITHOUT=""
1313 AVAIL_BCONDS_WITH=""
1314 if `grep -q ^%bcond ${SPECFILE}`; then
1315 BCOND_VERSION="NEW"
1316 elif `egrep -q ^#\ *_with ${SPECFILE}`; then
1317 BCOND_VERSION="OLD"
1318 else
1319 return
301cbfd4
ER
1320 fi
1321
117d9861
ER
1322 local bcond_avail=$(find_spec_bcond $SPECFILE)
1323 process_bcondrc "$SPECFILE"
1324
fa4bf1df 1325 update_shell_title "parse bconds"
cd445739 1326 case "${BCOND_VERSION}" in
fa4bf1df 1327 NONE)
7e365483 1328 :
cd445739 1329 ;;
7e365483 1330 OLD)
cd445739 1331 echo "Warning: This spec has old style bconds. Fix it || die."
fa4bf1df 1332 for opt in `echo "$bcond_avail" | grep ^_without_`
cd445739 1333 do
fa4bf1df
ER
1334 AVAIL_BCOND_WITHOUT=${opt#_without_}
1335 if [[ "$BCOND" = *--without?${AVAIL_BCOND_WITHOUT}* ]]; then
cd445739
AM
1336 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT <$AVAIL_BCOND_WITHOUT>"
1337 else
1338 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT $AVAIL_BCOND_WITHOUT"
1339 fi
1340 done
2a5f078d 1341
fa4bf1df 1342 for opt in `echo "$bcond_avail" | grep ^_with_`
cd445739 1343 do
fa4bf1df
ER
1344 AVAIL_BCOND_WITH=${opt#_with_}
1345 if [[ "$BCOND" = *--with?${AVAIL_BCOND_WITH}* ]]; then
cd445739
AM
1346 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH <$AVAIL_BCOND_WITH>"
1347 else
1348 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH $AVAIL_BCOND_WITH"
1349 fi
1350 done
1351 ;;
1352 NEW)
fa4bf1df
ER
1353 local cond_type="" # with || without
1354 for opt in $bcond_avail; do
cd445739
AM
1355 case "$opt" in
1356 _without)
1357 cond_type="without"
1358 ;;
1359 _with)
1360 cond_type="with"
1361 ;;
f8d24cee 1362 _without_*)
fa4bf1df
ER
1363 AVAIL_BCOND_WITHOUT=${opt#_without_}
1364 if [[ "$BCOND" = *--without?${AVAIL_BCOND_WITHOUT}* ]]; then
f8d24cee 1365 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT <$AVAIL_BCOND_WITHOUT>"
1366 else
1367 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT $AVAIL_BCOND_WITHOUT"
1368 fi
1369 ;;
1370 _with_*)
fa4bf1df
ER
1371 AVAIL_BCOND_WITH=${opt#_with_}
1372 if [[ "$BCOND" = *--with?${AVAIL_BCOND_WITH}* ]]; then
f8d24cee 1373 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH <$AVAIL_BCOND_WITH>"
1374 else
1375 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH $AVAIL_BCOND_WITH"
1376 fi
1377 ;;
cd445739
AM
1378 *)
1379 case "$cond_type" in
1380 with)
1381 cond_type=''
1382 AVAIL_BCOND_WITH="$opt"
fa4bf1df 1383 if [[ "$BCOND" = *--with?${AVAIL_BCOND_WITH}* ]]; then
cd445739
AM
1384 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH <$AVAIL_BCOND_WITH>"
1385 else
1386 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH $AVAIL_BCOND_WITH"
1387 fi
7e365483 1388 ;;
cd445739
AM
1389 without)
1390 cond_type=''
1391 AVAIL_BCOND_WITHOUT="$opt"
fa4bf1df 1392 if [[ "$BCOND" = *--without?${AVAIL_BCOND_WITHOUT}* ]]; then
cd445739
AM
1393 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT <$AVAIL_BCOND_WITHOUT>"
1394 else
1395 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT $AVAIL_BCOND_WITHOUT"
1396 fi
1397 ;;
1398 esac
1399 ;;
1400 esac
1401 done
1402 ;;
1403 esac
1404}
1405
1406run_sub_builder()
1407{
1408 package_name="${1}"
af6b168f 1409 update_shell_title "run_sub_builder $package_name"
cd445739
AM
1410 #
1411